{{ cordic.spin }}
CON



OBJ


PUB Begin (param_address)
  RESULT := cognew (@cordic, param_address)
  	 

DAT
              org       0

cordic        mov       parm, par
              mov	cosine, parm
              add       parm, #4
	      mov	sine, parm
	      add	parm, #4


	      mov	phase, #0
	      mov	time, cnt
	      add	time, period
:mainloop     waitcnt	time, period
	      rdlong    freq, parm
	      add	parm, #4
	      rdlong	mode, parm
	      sub	parm, #4
              add	phase, freq

	      mov	aa, phase

	      cmp	mode, #0  wz
        if_z  call	#:rotate
	      cmp	mode, #1  wz
	if_z  call	#:square
	      cmp	mode, #2  wz
	if_z  call	#:triangle

	      sar	xx, #8
	      maxs	xx, maxvalue
	      mins	xx, minvalue
	      wrlong	xx, cosine
	      sar	yy, #8
	      maxs	yy, maxvalue
	      mins	yy, minvalue
	      wrlong	yy, sine
              jmp       #:mainloop

:square	      mov	xx, aa
	      mov	yy, aa
	      add	xx, angle_90

	      cmps	xx, #0  wc
	      negc	xx, square_amp
	      cmps	yy, #0  wc
	      negc	yy, square_amp
:square_ret   ret


:rotate       mov	xx, sine_amp
	      mov	yy, #0 
	      test      aa, top2bits  wc        ' test for negative Y quadrants and rotate 180
        if_c  add       aa, topbit
              negc      xx, xx
              negc      yy, yy

              mov       shift, #0               ' loop variables init
              mov       corindex, #corlut       ' register number of current table entry
              mov       nn, #27

:loop         movs      :loadins, corindex      ' overwrite source register with table entry regnum
              add       corindex, #1            ' can't use loadins straight away, remember
:loadins      mov       da, corlut              ' this modified instruction indexes corlut
              mov       dx, yy
              sar       dx, shift               ' dx = yy >> ii
              neg       dy, xx
              sar       dy, shift               ' dy = -xx >> ii
              add       shift, #1
              cmps      aa, #0  wc              ' drive angle to zero
              sumnc     aa, da                  ' sumnc instruction very handy for this.
              sumnc     xx, dx
              sumnc     yy, dy
              djnz      nn, #:loop              ' 52 cycles per loop, 27 loops = 1404 cycles
:rotate_ret   ret

:triangle     mov	xx, aa
	      mov	yy, aa
	      sub	yy, angle_90

	      cmps	xx, #0  wc
	      shl	xx, #1
	if_c  add	xx, angle_180
	if_nc mov	tmp, angle_180
	if_nc sub	tmp, xx
	if_nc mov	xx, tmp

	      cmps	yy, #0  wc
	      shl	yy, #1
	if_c  add	yy, angle_180
	if_nc mov	tmp, angle_180
	if_nc sub	tmp, yy
	if_nc mov	yy, tmp
:triangle_ret ret

period	      long	$800

square_amp    long	1239850240
sine_amp      long	1064764928

angle_90      long      $40000000
angle_180     long      $80000000

minvalue      long	$FF800001
maxvalue      long	$007FFFFF

topbit        long      $80000000
top2bits      long      $C0000000

mulfactor     long      $4dba76d4         ' 0.60725293500888 * 2^31  = 1304065748
decfactor     long      607252935         ' scale factor times 10^9


corlut        long      $20000000               ' CORDIC angle lookup table
              long      $12E4051E
              long      $09FB385B
              long      $051111D4
              long      $028B0D43
              long      $0145D7E1
              long      $00A2F61E
              long      $00517C55
              long      $0028BE53
              long      $00145F2F
              long      $000A2F98
              long      $000517CC
              long      $00028BE6
              long      $000145F3
              long      $0000A2FA
              long      $0000517D
              long      $000028BE
              long      $0000145F
              long      $00000A30
              long      $00000518
              long      $0000028C
              long      $00000146
              long      $000000A3
              long      $00000051
              long      $00000029
              long      $00000014
              long      $0000000A
              long      $00000005
              long      $00000003
              long      $00000001

parm          res       1
time          res       1

aa            res       1
xx            res       1
yy            res       1
da            res       1
dx            res       1
dy            res       1
tmp           res       1

shift         res       1
nn            res       1
corindex      res       1

temp          res       1
cosine        res       1
sine          res       1
freq          res       1
mode	      res	1
phase         res       1
angle         res       1


	      fit	$1F0
